<?php
if (! class_exists('BookingPress_Global_Options') ) {
    class BookingPress_Global_Options
    {
        function __construct()
        {
        }

        function bookingpress_global_options()
        {
            $bookingpress_site_current_language = $this->bookingpress_get_site_current_language();
            if ($bookingpress_site_current_language == 'ru' ) {
                $bookingpress_site_current_language = 'ruRU';
            } elseif ($bookingpress_site_current_language == 'zh-cn' ) {
                $bookingpress_site_current_language = 'zhCN';
            } elseif ($bookingpress_site_current_language == 'pt-br' ) {
                $bookingpress_site_current_language = 'ptBr';
            } elseif ($bookingpress_site_current_language == 'sv' ) {
                $bookingpress_site_current_language = 'se';
            }

            $wp_default_time_format    = get_option('time_format');
            $bpa_converted_time_format = 'hh:mm a';
            if ($wp_default_time_format == 'g:i: a' ) {
                $bpa_converted_time_format = 'hh:mm a';
            } elseif ($wp_default_time_format == 'g:i: A' ) {
                $bpa_converted_time_format = 'hh:mm A';
            } elseif ($wp_default_time_format == 'H:i' ) {
                $bpa_converted_time_format = 'hh:mm';
            }

            $global_data = array(
            'name'                         => 'Appointment Booking',
            'debug'                        => true,
            'locale'                       => $bookingpress_site_current_language,
            'wp_default_date_format'       => get_option('date_format'),
            'wp_default_time_format'       => get_option('time_format'),
            'bpa_time_format_for_timeslot' => $bpa_converted_time_format,
            'pagination'                   => wp_json_encode(array( 10, 20, 50, 100, 200, 300, 400, 500 )),
            'customer_placeholders'        => wp_json_encode(
                array(
                        array(
                            'value' => '%customer_email%',
                            'name'  => '%customer_email%',
                ),
                array(
                'value' => '%customer_first_name%',
                'name'  => '%customer_first_name%',
                ),
                array(
                'value' => '%customer_full_name%',
                'name'  => '%customer_full_name%',
                ),
                array(
                'value' => '%customer_last_name%',
                'name'  => '%customer_last_name%',
                ),
                array(
                'value' => '%customer_note%',
                'name'  => '%customer_note%',
                ),
                array(
                'value' => '%customer_phone%',
                'name'  => '%customer_phone%',
                ),
                array(
                'value' => '%customer_cancel_appointment_link%',
                'name'  => '%customer_cancel_appointment_link%',
                ),
                )
            ),
            'service_placeholders'         => wp_json_encode(
                array(
                        array(
                            'value' => '%service_name%',
                            'name'  => '%service_name%',
	                ),
	                array(
		                'value' => '%service_amount%',
		                'name'  => '%service_amount%',
	                ),
	                array(
		                'value' => '%service_duration%',
		                'name'  => '%service_duration%',
	                ),
			array(
				'value' => '%category_name%',
				'name'  => '%category_name%',
			),
                )
            ),
            'company_placeholders'         => wp_json_encode(
                array(
                        array(
                            'value' => '%company_address%',
                            'name'  => '%company_address%',
                ),
                array(
                'value' => '%company_name%',
                'name'  => '%company_name%',
                ),
                array(
                'value' => '%company_phone%',
                'name'  => '%company_phone%',
                ),
                array(
                'value' => '%company_website%',
                'name'  => '%company_website%',
                ),
                )
            ),
            'appointment_placeholders'     => wp_json_encode(
                array(
                        array(
                            'value' => '%appointment_date%',
                            'name'  => '%appointment_date%',
                ),
                array(
                'value' => '%appointment_time%',
                'name'  => '%appointment_time%',
                ),
                )
            ),
            'country_lists'                => '[{"code":"ad","name":"Andorra"},{"code":"ae","name":"United Arab Emirates"},{"code":"af","name":"Afghanistan"},{"code":"ag","name":"Antigua & Barbuda"},{"code":"ai","name":"Anguilla"},{"code":"al","name":"Albania"},{"code":"am","name":"Armenia"},{"code":"ao","name":"Angola"},{"code":"aq","name":"Antarctica"},{"code":"ar","name":"Argentina"},{"code":"as","name":"American Samoa"},{"code":"at","name":"Austria"},{"code":"au","name":"Australia"},{"code":"aw","name":"Aruba"},{"code":"ax","name":"Aland Islands"},{"code":"az","name":"Azerbaijan"},{"code":"ba","name":"Bosnia & Herzegovina"},{"code":"bb","name":"Barbados"},{"code":"bd","name":"Bangladesh"},{"code":"be","name":"Belgium"},{"code":"bf","name":"Burkina Faso"},{"code":"bg","name":"Bulgaria"},{"code":"bh","name":"Bahrain"},{"code":"bi","name":"Burundi"},{"code":"bj","name":"Benin"},{"code":"bm","name":"Bermuda"},{"code":"bn","name":"Brunei"},{"code":"bo","name":"Bolivia"},{"code":"br","name":"Brazil"},{"code":"bs","name":"Bahamas"},{"code":"bt","name":"Bhutan"},{"code":"bv","name":"Bouvet Island"},{"code":"bw","name":"Botswana"},{"code":"by","name":"Belarus"},{"code":"bz","name":"Belize"},{"code":"ca","name":"Canada"},{"code":"cc","name":"Cocos (Keeling) Islands"},{"code":"cd","name":"Congo - Kinshasa"},{"code":"cf","name":"Central African Republic"},{"code":"cg","name":"Congo - Brazzaville"},{"code":"ch","name":"Switzerland"},{"code":"ci","name":"Cote D\'Ivoire (Ivory Coast)"},{"code":"ck","name":"Cook Islands"},{"code":"cl","name":"Chile"},{"code":"cm","name":"Cameroon"},{"code":"cn","name":"China"},{"code":"co","name":"Colombia"},{"code":"cr","name":"Costa Rica"},{"code":"cu","name":"Cuba"},{"code":"cv","name":"Cape Verde"},{"code":"cx","name":"Christmas Island"},{"code":"cy","name":"Cyprus"},{"code":"cz","name":"Czechia"},{"code":"de","name":"Germany"},{"code":"dj","name":"Djibouti"},{"code":"dk","name":"Denmark"},{"code":"dm","name":"Dominica"},{"code":"do","name":"Dominican Republic"},{"code":"dz","name":"Algeria"},{"code":"ec","name":"Ecuador"},{"code":"ee","name":"Estonia"},{"code":"eg","name":"Egypt"},{"code":"eh","name":"Western Sahara"},{"code":"er","name":"Eritrea"},{"code":"es","name":"Spain"},{"code":"et","name":"Ethiopia"},{"code":"fi","name":"Finland"},{"code":"fj","name":"Fiji"},{"code":"fk","name":"Falkland Islands"},{"code":"fm","name":"Micronesia"},{"code":"fo","name":"Faroe Islands"},{"code":"fr","name":"France"},{"code":"ga","name":"Gabon"},{"code":"gb","name":"United Kingdom"},{"code":"gd","name":"Grenada"},{"code":"ge","name":"Georgia"},{"code":"gf","name":"French Guiana"},{"code":"gh","name":"Ghana"},{"code":"gi","name":"Gibraltar"},{"code":"gl","name":"Greenland"},{"code":"gm","name":"Gambia"},{"code":"gn","name":"Guinea"},{"code":"gp","name":"Guadeloupe"},{"code":"gq","name":"Equatorial Guinea"},{"code":"gr","name":"Greece"},{"code":"gs","name":"South Georgia & South Sandwich Islands"},{"code":"gt","name":"Guatemala"},{"code":"gu","name":"Guam"},{"code":"gw","name":"Guinea-Bissau"},{"code":"gy","name":"Guyana"},{"code":"hk","name":"Hong Kong"},{"code":"hm","name":"Heard & McDonald Islands"},{"code":"hn","name":"Honduras"},{"code":"hr","name":"Croatia"},{"code":"ht","name":"Haiti"},{"code":"hu","name":"Hungary"},{"code":"id","name":"Indonesia"},{"code":"ie","name":"Ireland"},{"code":"il","name":"Israel"},{"code":"in","name":"India"},{"code":"io","name":"British Indian Ocean Territory"},{"code":"iq","name":"Iraq"},{"code":"ir","name":"Iran"},{"code":"is","name":"Iceland"},{"code":"it","name":"Italy"},{"code":"jm","name":"Jamaica"},{"code":"jo","name":"Jordan"},{"code":"jp","name":"Japan"},{"code":"ke","name":"Kenya"},{"code":"kg","name":"Kyrgyzstan"},{"code":"kh","name":"Cambodia"},{"code":"ki","name":"Kiribati"},{"code":"km","name":"Comoros"},{"code":"kn","name":"St. Kitts & Nevis"},{"code":"kp","name":"North Korea"},{"code":"kr","name":"South Korea"},{"code":"kw","name":"Kuwait"},{"code":"ky","name":"Cayman Islands"},{"code":"kz","name":"Kazakhstan"},{"code":"la","name":"Laos"},{"code":"lb","name":"Lebanon"},{"code":"lc","name":"St. Lucia"},{"code":"li","name":"Liechtenstein"},{"code":"lk","name":"Sri Lanka"},{"code":"lr","name":"Liberia"},{"code":"ls","name":"Lesotho"},{"code":"lt","name":"Lithuania"},{"code":"lu","name":"Luxembourg"},{"code":"lv","name":"Latvia"},{"code":"ly","name":"Libya"},{"code":"ma","name":"Morocco"},{"code":"mc","name":"Monaco"},{"code":"md","name":"Moldova"},{"code":"me","name":"Montenegro"},{"code":"mg","name":"Madagascar"},{"code":"mh","name":"Marshall Islands"},{"code":"mk","name":"Macedonia"},{"code":"ml","name":"Mali"},{"code":"mm","name":"Myanmar (Burma)"},{"code":"mn","name":"Mongolia"},{"code":"mo","name":"Macau"},{"code":"mp","name":"Northern Mariana Islands"},{"code":"mq","name":"Martinique"},{"code":"mr","name":"Mauritania"},{"code":"ms","name":"Montserrat"},{"code":"mt","name":"Malta"},{"code":"mu","name":"Mauritius"},{"code":"mv","name":"Maldives"},{"code":"mw","name":"Malawi"},{"code":"mx","name":"Mexico"},{"code":"my","name":"Malaysia"},{"code":"mz","name":"Mozambique"},{"code":"na","name":"Namibia"},{"code":"nc","name":"New Caledonia"},{"code":"ne","name":"Niger"},{"code":"nf","name":"Norfolk Island"},{"code":"ng","name":"Nigeria"},{"code":"ni","name":"Nicaragua"},{"code":"nl","name":"Netherlands"},{"code":"no","name":"Norway"},{"code":"np","name":"Nepal"},{"code":"nr","name":"Nauru"},{"code":"nu","name":"Niue"},{"code":"nz","name":"New Zealand"},{"code":"om","name":"Oman"},{"code":"pa","name":"Panama"},{"code":"pe","name":"Peru"},{"code":"pf","name":"French Polynesia"},{"code":"pg","name":"Papua New Guinea"},{"code":"ph","name":"Philippines"},{"code":"pk","name":"Pakistan"},{"code":"pl","name":"Poland"},{"code":"pm","name":"St. Pierre & Miquelon"},{"code":"pn","name":"Pitcairn"},{"code":"pr","name":"Puerto Rico"},{"code":"ps","name":"Palestinian Territories"},{"code":"pt","name":"Portugal"},{"code":"pw","name":"Palau"},{"code":"py","name":"Paraguay"},{"code":"qa","name":"Qatar"},{"code":"re","name":"Reunion"},{"code":"ro","name":"Romania"},{"code":"ru","name":"Russia"},{"code":"rw","name":"Rwanda"},{"code":"sa","name":"Saudi Arabia"},{"code":"sb","name":"Solomon Islands"},{"code":"sc","name":"Seychelles"},{"code":"sd","name":"Sudan"},{"code":"se","name":"Sweden"},{"code":"sg","name":"Singapore"},{"code":"sh","name":"St. Helena"},{"code":"si","name":"Slovenia"},{"code":"sj","name":"Svalbard & Jan Mayen"},{"code":"sk","name":"Slovakia"},{"code":"sl","name":"Sierra Leone"},{"code":"sm","name":"San Marino"},{"code":"sn","name":"Senegal"},{"code":"so","name":"Somalia"},{"code":"sr","name":"Suriname"},{"code":"ss","name":"South Sudan"},{"code":"st","name":"Sao Tome and Principe"},{"code":"sv","name":"El Salvador"},{"code":"sy","name":"Syria"},{"code":"sz","name":"Swaziland"},{"code":"tc","name":"Turks & Caicos Islands"},{"code":"td","name":"Chad"},{"code":"tf","name":"French Southern Territories"},{"code":"tg","name":"Togo"},{"code":"th","name":"Thailand"},{"code":"tj","name":"Tajikistan"},{"code":"tk","name":"Tokelau"},{"code":"tl","name":"Timor-Leste"},{"code":"tm","name":"Turkmenistan"},{"code":"tn","name":"Tunisia"},{"code":"to","name":"Tonga"},{"code":"tr","name":"Turkey"},{"code":"tt","name":"Trinidad & Tobago"},{"code":"tv","name":"Tuvalu"},{"code":"tw","name":"Taiwan"},{"code":"tz","name":"Tanzania"},{"code":"ua","name":"Ukraine"},{"code":"ug","name":"Uganda"},{"code":"um","name":"U.S. Outlying Islands"},{"code":"us","name":"United States"},{"code":"uy","name":"Uruguay"},{"code":"uz","name":"Uzbekistan"},{"code":"va","name":"Vatican City"},{"code":"vc","name":"St. Vincent & Grenadines"},{"code":"ve","name":"Venezuela"},{"code":"vg","name":"British Virgin Islands"},{"code":"vi","name":"U.S. Virgin Islands"},{"code":"vn","name":"Vietnam"},{"code":"vu","name":"Vanuatu"},{"code":"wf","name":"Wallis & Futuna"},{"code":"ws","name":"Samoa"},{"code":"ye","name":"Yemen"},{"code":"yt","name":"Mayotte"},{"code":"za","name":"South Africa"},{"code":"zm","name":"Zambia"},{"code":"zw","name":"Zimbabwe"}]',

            'countries_json_details'       => '[{"symbol":"$","name":"US Dollar","symbol_native":"$","code":"USD","iso":"us"},{"symbol":"€","name":"Euro","symbol_native":"€","code":"EUR","iso":"eu"},{"symbol":"£","name":"British Pound Sterling","symbol_native":"£","code":"GBP","iso":"gb"},{"symbol":"CA$","name":"Canadian Dollar","symbol_native":"$","code":"CAD","iso":"ca"},{"symbol":"FCFP","name":"CFP Franc","symbol_native":"FCFP","code":"XPF","iso":"fr"},{"symbol":"CHF","name":"Swiss Franc","symbol_native":"CHF","code":"CHF","iso":"ch"},{"symbol":"RUB","name":"Russian Ruble","symbol_native":"руб.","code":"RUB","iso":"ru"},{"symbol":"¥","name":"Japanese Yen","symbol_native":"￥","code":"JPY","iso":"jp"},{"symbol":"Af","name":"Afghan Afghani","symbol_native":"؋","code":"AFN","iso":"af"},{"symbol":"ALL","name":"Albanian Lek","symbol_native":"Lek","code":"ALL","iso":"al"},{"symbol":"DA","name":"Algerian Dinar","symbol_native":"د.ج.‏","code":"DZD","iso":"dz"},{"symbol":"AR$","name":"Argentine Peso","symbol_native":"$","code":"ARS","iso":"ar"},{"symbol":"AMD","name":"Armenian Dram","symbol_native":"դր.","code":"AMD","iso":"am"},{"symbol":"AU$","name":"Australian Dollar","symbol_native":"$","code":"AUD","iso":"au"},{"symbol":"man.","name":"Azerbaijani Manat","symbol_native":"ман.","code":"AZN","iso":"az"},{"symbol":"BD","name":"Bahraini Dinar","symbol_native":"د.ب.‏","code":"BHD","iso":"bh"},{"symbol":"Tk","name":"Bangladeshi Taka","symbol_native":"৳","code":"BDT","iso":"bd"},{"symbol":"BYR","name":"Belarusian Ruble","symbol_native":"BYR","code":"BYR","iso":"by"},{"symbol":"BZ$","name":"Belize Dollar","symbol_native":"$","code":"BZD","iso":"bz"},{"symbol":"Bs","name":"Bolivian Boliviano","symbol_native":"Bs","code":"BOB","iso":"bo"},{"symbol":"KM","name":"Bosnia-Herzegovina Convertible Mark","symbol_native":"KM","code":"BAM","iso":"ba"},{"symbol":"BWP","name":"Botswanan Pula","symbol_native":"P","code":"BWP","iso":"bw"},{"symbol":"R$","name":"Brazilian Real","symbol_native":"R$","code":"BRL","iso":"br"},{"symbol":"BN$","name":"Brunei Dollar","symbol_native":"$","code":"BND","iso":"bn"},{"symbol":"BGN","name":"Bulgarian Lev","symbol_native":"лв.","code":"BGN","iso":"bg"},{"symbol":"FBu","name":"Burundian Franc","symbol_native":"FBu","code":"BIF","iso":"bi"},{"symbol":"KHR","name":"Cambodian Riel","symbol_native":"៛","code":"KHR","iso":"kh"},{"symbol":"CV$","name":"Cape Verdean Escudo","symbol_native":"CV$","code":"CVE","iso":"cv"},{"symbol":"CLP","name":"Chilean Peso","symbol_native":"$","code":"CLP","iso":"cl"},{"symbol":"CN¥","name":"Chinese Yuan","symbol_native":"CN¥","code":"CNY","iso":"cn"},{"symbol":"COP","name":"Colombian Peso","symbol_native":"$","code":"COP","iso":"co"},{"symbol":"CF","name":"Comorian Franc","symbol_native":"FC","code":"KMF","iso":"km"},{"symbol":"CDF","name":"Congolese Franc","symbol_native":"FrCD","code":"CDF","iso":"cd"},{"symbol":"₡","name":"Costa Rican Colón","symbol_native":"₡","code":"CRC","iso":"cr"},{"symbol":"kn","name":"Croatian Kuna","symbol_native":"kn","code":"HRK","iso":"hr"},{"symbol":"Kč","name":"Czech Republic Koruna","symbol_native":"Kč","code":"CZK","iso":"cz"},{"symbol":"Dkk","name":"Danish Krone","symbol_native":"kr","code":"DKK","iso":"dk"},{"symbol":"Fdj","name":"Djiboutian Franc","symbol_native":"Fdj","code":"DJF","iso":"dj"},{"symbol":"RD$","name":"Dominican Peso","symbol_native":"RD$","code":"DOP","iso":"do"},{"symbol":"EGP","name":"Egyptian Pound","symbol_native":"ج.م.‏","code":"EGP","iso":"eg"},{"symbol":"Nfk","name":"Eritrean Nakfa","symbol_native":"Nfk","code":"ERN","iso":"er"},{"symbol":"Ekr","name":"Estonian Kroon","symbol_native":"kr","code":"EEK","iso":"ee"},{"symbol":"Br","name":"Ethiopian Birr","symbol_native":"Br","code":"ETB","iso":"et"},{"symbol":"GEL","name":"Georgian Lari","symbol_native":"GEL","code":"GEL","iso":"ge"},{"symbol":"GH₵","name":"Ghanaian Cedi","symbol_native":"GH₵","code":"GHS","iso":"gh"},{"symbol":"GTQ","name":"Guatemalan Quetzal","symbol_native":"Q","code":"GTQ","iso":"gt"},{"symbol":"FG","name":"Guinean Franc","symbol_native":"FG","code":"GNF","iso":"gn"},{"symbol":"HNL","name":"Honduran Lempira","symbol_native":"L","code":"HNL","iso":"hn"},{"symbol":"HK$","name":"Hong Kong Dollar","symbol_native":"$","code":"HKD","iso":"hk"},{"symbol":"Ft","name":"Hungarian Forint","symbol_native":"Ft","code":"HUF","iso":"hu"},{"symbol":"kr","name":"Icelandic Króna","symbol_native":"kr","code":"ISK","iso":"is"},{"symbol":"INR","name":"Indian Rupee","symbol_native":"টকা","code":"INR","iso":"in"},{"symbol":"Rp","name":"Indonesian Rupiah","symbol_native":"Rp","code":"IDR","iso":"id"},{"symbol":"IRR","name":"Iranian Rial","symbol_native":"﷼","code":"IRR","iso":"ir"},{"symbol":"IQD","name":"Iraqi Dinar","symbol_native":"د.ع.‏","code":"IQD","iso":"iq"},{"symbol":"₪","name":"Israeli New Sheqel","symbol_native":"₪","code":"ILS","iso":"il"},{"symbol":"J$","name":"Jamaican Dollar","symbol_native":"$","code":"JMD","iso":"jm"},{"symbol":"JD","name":"Jordanian Dinar","symbol_native":"د.أ.‏","code":"JOD","iso":"jo"},{"symbol":"KZT","name":"Kazakhstani Tenge","symbol_native":"тңг.","code":"KZT","iso":"kz"},{"symbol":"Ksh","name":"Kenyan Shilling","symbol_native":"Ksh","code":"KES","iso":"ke"},{"symbol":"KD","name":"Kuwaiti Dinar","symbol_native":"د.ك.‏","code":"KWD","iso":"kw"},{"symbol":"Ls","name":"Latvian Lats","symbol_native":"Ls","code":"LVL","iso":"lv"},{"symbol":"LB£","name":"Lebanese Pound","symbol_native":"ل.ل.‏","code":"LBP","iso":"lb"},{"symbol":"LD","name":"Libyan Dinar","symbol_native":"د.ل.‏","code":"LYD","iso":"ly"},{"symbol":"Lt","name":"Lithuanian Litas","symbol_native":"Lt","code":"LTL","iso":"lt"},{"symbol":"MOP$","name":"Macanese Pataca","symbol_native":"MOP$","code":"MOP","iso":"mo"},{"symbol":"MKD","name":"Macedonian Denar","symbol_native":"MKD","code":"MKD","iso":"mk"},{"symbol":"MGA","name":"Malagasy Ariary","symbol_native":"MGA","code":"MGA","iso":"mg"},{"symbol":"RM","name":"Malaysian Ringgit","symbol_native":"RM","code":"MYR","iso":"my"},{"symbol":"MURs","name":"Mauritian Rupee","symbol_native":"MURs","code":"MUR","iso":"mu"},{"symbol":"MX$","name":"Mexican Peso","symbol_native":"$","code":"MXN","iso":"mx"},{"symbol":"MDL","name":"Moldovan Leu","symbol_native":"MDL","code":"MDL","iso":"md"},{"symbol":"MAD","name":"Moroccan Dirham","symbol_native":"د.م.‏","code":"MAD","iso":"ma"},{"symbol":"MTn","name":"Mozambican Metical","symbol_native":"MTn","code":"MZN","iso":"mz"},{"symbol":"MMK","name":"Myanma Kyat","symbol_native":"K","code":"MMK","iso":"mm"},{"symbol":"N$","name":"Namibian Dollar","symbol_native":"N$","code":"NAD","iso":"na"},{"symbol":"NPRs","name":"Nepalese Rupee","symbol_native":"नेरू","code":"NPR","iso":"np"},{"symbol":"NT$","name":"New Taiwan Dollar","symbol_native":"NT$","code":"TWD","iso":"tw"},{"symbol":"NZ$","name":"New Zealand Dollar","symbol_native":"$","code":"NZD","iso":"nz"},{"symbol":"C$","name":"Nicaraguan Córdoba","symbol_native":"C$","code":"NIO","iso":"ni"},{"symbol":"₦","name":"Nigerian Naira","symbol_native":"₦","code":"NGN","iso":"ng"},{"symbol":"kr","name":"Norwegian Krone","symbol_native":"kr","code":"NOK","iso":"no"},{"symbol":"OMR","name":"Omani Rial","symbol_native":"ر.ع.‏","code":"OMR","iso":"om"},{"symbol":"PKRs","name":"Pakistani Rupee","symbol_native":"₨","code":"PKR","iso":"pk"},{"symbol":"B/.","name":"Panamanian Balboa","symbol_native":"B/.","code":"PAB","iso":"pa"},{"symbol":"₲","name":"Paraguayan Guarani","symbol_native":"₲","code":"PYG","iso":"py"},{"symbol":"S/.","name":"Peruvian Nuevo Sol","symbol_native":"S/.","code":"PEN","iso":"pe"},{"symbol":"₱","name":"Philippine Peso","symbol_native":"₱","code":"PHP","iso":"ph"},{"symbol":"zł","name":"Polish Zloty","symbol_native":"zł","code":"PLN","iso":"pl"},{"symbol":"QR","name":"Qatari Rial","symbol_native":"ر.ق.‏","code":"QAR","iso":"qa"},{"symbol":"RON","name":"Romanian Leu","symbol_native":"RON","code":"RON","iso":"ro"},{"symbol":"RWF","name":"Rwandan Franc","symbol_native":"FR","code":"RWF","iso":"rw"},{"symbol":"SR","name":"Saudi Riyal","symbol_native":"ر.س.‏","code":"SAR","iso":"sa"},{"symbol":"rsd.","name":"Serbian Dinar","symbol_native":"дин.","code":"RSD","iso":"rs"},{"symbol":"S$","name":"Singapore Dollar","symbol_native":"$","code":"SGD","iso":"sg"},{"symbol":"Ssh","name":"Somali Shilling","symbol_native":"Ssh","code":"SOS","iso":"so"},{"symbol":"R","name":"South African Rand","symbol_native":"R","code":"ZAR","iso":"za"},{"symbol":"₩","name":"South Korean Won","symbol_native":"₩","code":"KRW","iso":"kr"},{"symbol":"₭","name":"Lao kip","symbol_native":"₭","code":"LAK","iso":"la"},{"symbol":"SLRs","name":"Sri Lankan Rupee","symbol_native":"SL Re","code":"LKR","iso":"lk"},{"symbol":"SDG","name":"Sudanese Pound","symbol_native":"SDG","code":"SDG","iso":"sd"},{"symbol":"kr","name":"Swedish Krona","symbol_native":"kr","code":"SEK","iso":"se"},{"symbol":"SY£","name":"Syrian Pound","symbol_native":"ل.س.‏","code":"SYP","iso":"sy"},{"symbol":"TSh","name":"Tanzanian Shilling","symbol_native":"TSh","code":"TZS","iso":"tz"},{"symbol":"฿","name":"Thai Baht","symbol_native":"฿","code":"THB","iso":"th"},{"symbol":"T$","name":"Tongan Paʻanga","symbol_native":"T$","code":"TOP","iso":"to"},{"symbol":"TT$","name":"Trinidad and Tobago Dollar","symbol_native":"$","code":"TTD","iso":"tt"},{"symbol":"DT","name":"Tunisian Dinar","symbol_native":"د.ت.‏","code":"TND","iso":"tn"},{"symbol":"TL","name":"Turkish Lira","symbol_native":"TL","code":"TRY","iso":"tr"},{"symbol":"USh","name":"Ugandan Shilling","symbol_native":"USh","code":"UGX","iso":"ug"},{"symbol":"₴","name":"Ukrainian Hryvnia","symbol_native":"₴","code":"UAH","iso":"ua"},{"symbol":"AED","name":"United Arab Emirates Dirham","symbol_native":"د.إ.‏","code":"AED","iso":"ae"},{"symbol":"$U","name":"Uruguayan Peso","symbol_native":"$","code":"UYU","iso":"uy"},{"symbol":"UZS","name":"Uzbekistan Som","symbol_native":"UZS","code":"UZS","iso":"uz"},{"symbol":"Bs.S.","name":"Venezuelan Bolívar","symbol_native":"Bs.S.","code":"VES","iso":"ve"},{"symbol":"₫","name":"Vietnamese Dong","symbol_native":"₫","code":"VND","iso":"vn"},{"symbol":"YR","name":"Yemeni Rial","symbol_native":"ر.ي.‏","code":"YER","iso":"ye"},{"symbol":"ZK","name":"Zambian Kwacha","symbol_native":"ZK","code":"ZMK","iso":"zm"}]',
            'timepicker_options'           => wp_json_encode(
                array(
                        'start' => '00:00',
                        'step'  => '00:15',
                        'end'   => '24:00',
                )
            ),
            'work_hours_days'              => wp_json_encode(
                array(
                        array(
                            'day_key'           => 'monday',
                            'day_name'          => 'Monday',
                            'day_services_data' => array(),
                ),
                array(
                'day_key'           => 'tuesday',
                'day_name'          => 'Tuesday',
                'day_services_data' => array(),
                ),
                array(
                'day_key'           => 'wednesday',
                'day_name'          => 'Wednesday',
                'day_services_data' => array(),
                ),
                array(
                'day_key'           => 'thursday',
                'day_name'          => 'Thursday',
                'day_services_data' => array(),
                ),
                array(
                'day_key'           => 'friday',
                'day_name'          => 'Friday',
                'day_services_data' => array(),
                ),
                array(
                'day_key'           => 'saturday',
                'day_name'          => 'Saturday',
                'day_services_data' => array(),
                ),
                array(
                'day_key'           => 'sunday',
                'day_name'          => 'Sunday',
                'day_services_data' => array(),
                ),
                )
            ),
            'allowed_html'                 => wp_json_encode(
                array(
                        'a'          => array(
                            'title'  => array(),
                            'href'   => array(),
                            'target' => array(),
                            'class'  => array(),
                            'id'     => array(),
                            'style'  => array(),
                ),
                'b'          => array(),
                'blockquote' => array(),
                'br'         => array(),
                'button'     => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                'title' => array(),
                ),
                'canvas'     => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'center'     => array(),
                'code'       => array(),
                'dd'         => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'del'        => array(
                'datetime' => array(),
                'title'    => array(),
                ),
                'div'        => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                'title' => array(),
                ),
                'dl'         => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'dt'         => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'em'         => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'embed'      => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'font'       => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'frame'      => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'frameset'   => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'h1'         => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'h2'         => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'h3'         => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'h4'         => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'h5'         => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'hr'         => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'i'          => array(),
                'iframe'     => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'img'        => array(
                'class'  => array(),
                'id'     => array(),
                'style'  => array(),
                'src'    => array(),
                'alt'    => array(),
                'height' => array(),
                'width'  => array(),
                ),
                'label'      => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                'for'   => array(),
                ),
                'li'         => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'link'       => array(
                'href' => array(),
                'type' => array(),
                ),
                'meta'       => array(),
                'object'     => array(),
                'ol'         => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'p'          => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'path'       => array(
                'id'        => array(),
                'd'         => array(),
                'fill'      => array(),
                'fill-rule' => array(),
                'clip-rule' => array(),
                ),
                'pre'        => array(),
                'q'          => array(
                'cite'  => array(),
                'title' => array(),
                ),
                'span'       => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                'title' => array(),
                ),
                'strike'     => array(),
                'sub'        => array(),
                'sup'        => array(),
                'svg'        => array(
                'id'      => array(),
                'height'  => array(),
                'width'   => array(),
                'x'       => array(),
                'y'       => array(),
                'viewBox' => array(),
                ),
                'strong'     => array(),
                'style'      => array(
                'type' => array(),
                ),
                'tfooter'    => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'tbody'      => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'thead'      => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'th'         => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'td'         => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'tr'         => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'table'      => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                'u'          => array(),
                'ul'         => array(
                'class' => array(),
                'id'    => array(),
                'style' => array(),
                ),
                )
            ),
            );

            $global_data = apply_filters('bookingpress_add_global_option_data', $global_data);
            return $global_data;
        }

        function bookingpress_get_default_fonts()
        {
            return array(
            'Inherit Fonts',
            'Arial',
            'Helvetica',
            'sans-serif',
            'Lucida Grande',
            'Lucida Sans Unicode',
            'Tahoma',
            'Times New Roman',
            'Courier New',
            'Verdana',
            'Geneva',
            'Courier',
            'Monospace',
            'Times',
            'Open Sans Semibold',
            'Open Sans Bold',
            );
        }

        function bookingpress_get_google_fonts()
        {
            return array(
            'ABeeZee',
            'Abel',
            'Abhaya Libre',
            'Abril Fatface',
            'Aclonica',
            'Acme',
            'Actor',
            'Adamina',
            'Advent Pro',
            'Aguafina Script',
            'Akronim',
            'Aladin',
            'Aldrich',
            'Alef',
            'Alegreya',
            'Alegreya SC',
            'Alegreya Sans',
            'Alegreya Sans SC',
            'Alex Brush',
            'Alfa Slab One',
            'Alice',
            'Alike',
            'Alike Angular',
            'Allan',
            'Allerta',
            'Allerta Stencil',
            'Allura',
            'Almendra',
            'Almendra Display',
            'Almendra SC',
            'Amarante',
            'Amaranth',
            'Amatic SC',
            'Amethysta',
            'Amiko',
            'Amiri',
            'Amita',
            'Anaheim',
            'Andada',
            'Andika',
            'Angkor',
            'Annie Use Your Telescope',
            'Anonymous Pro',
            'Antic',
            'Antic Didone',
            'Antic Slab',
            'Anton',
            'Arapey',
            'Arbutus',
            'Arbutus Slab',
            'Architects Daughter',
            'Archivo',
            'Archivo Black',
            'Archivo Narrow',
            'Aref Ruqaa',
            'Arima Madurai',
            'Arimo',
            'Arizonia',
            'Armata',
            'Arsenal',
            'Artifika',
            'Arvo',
            'Arya',
            'Asap',
            'Asap Condensed',
            'Asar',
            'Asset',
            'Assistant',
            'Astloch',
            'Asul',
            'Athiti',
            'Atma',
            'Atomic Age',
            'Aubrey',
            'Audiowide',
            'Autour One',
            'Average',
            'Average Sans',
            'Averia Gruesa Libre',
            'Averia Libre',
            'Averia Sans Libre',
            'Averia Serif Libre',
            'Bad Script',
            'Bahiana',
            'Bai Jamjuree',
            'Baloo',
            'Baloo Bhai',
            'Baloo Bhaijaan',
            'Baloo Bhaina',
            'Baloo Chettan',
            'Baloo Da',
            'Baloo Paaji',
            'Baloo Tamma',
            'Baloo Tammudu',
            'Baloo Thambi',
            'Balthazar',
            'Bangers',
            'Barlow',
            'Barlow Condensed',
            'Barlow Semi Condensed',
            'Barrio',
            'Basic',
            'Battambang',
            'Baumans',
            'Bayon',
            'Belgrano',
            'Bellefair',
            'Belleza',
            'BenchNine',
            'Bentham',
            'Berkshire Swash',
            'Bevan',
            'Bigelow Rules',
            'Bigshot One',
            'Bilbo',
            'Bilbo Swash Caps',
            'BioRhyme',
            'BioRhyme Expanded',
            'Biryani',
            'Bitter',
            'Black And White Picture',
            'Black Han Sans',
            'Black Ops One',
            'Bokor',
            'Bonbon',
            'Boogaloo',
            'Bowlby One',
            'Bowlby One SC',
            'Brawler',
            'Bree Serif',
            'Bubblegum Sans',
            'Bubbler One',
            'Buda',
            'Buenard',
            'Bungee',
            'Bungee Hairline',
            'Bungee Inline',
            'Bungee Outline',
            'Bungee Shade',
            'Butcherman',
            'Butterfly Kids',
            'Cabin',
            'Cabin Condensed',
            'Cabin Sketch',
            'Caesar Dressing',
            'Cagliostro',
            'Cairo',
            'Calligraffitti',
            'Cambay',
            'Cambo',
            'Candal',
            'Cantarell',
            'Cantata One',
            'Cantora One',
            'Capriola',
            'Cardo',
            'Carme',
            'Carrois Gothic',
            'Carrois Gothic SC',
            'Carter One',
            'Catamaran',
            'Caudex',
            'Caveat',
            'Caveat Brush',
            'Cedarville Cursive',
            'Ceviche One',
            'Chakra Petch',
            'Changa',
            'Changa One',
            'Chango',
            'Charmonman',
            'Chathura',
            'Chau Philomene One',
            'Chela One',
            'Chelsea Market',
            'Chenla',
            'Cherry Cream Soda',
            'Cherry Swash',
            'Chewy',
            'Chicle',
            'Chivo',
            'Chonburi',
            'Cinzel',
            'Cinzel Decorative',
            'Clicker Script',
            'Coda',
            'Coda Caption',
            'Codystar',
            'Coiny',
            'Combo',
            'Comfortaa',
            'Coming Soon',
            'Concert One',
            'Condiment',
            'Content',
            'Contrail One',
            'Convergence',
            'Cookie',
            'Copse',
            'Corben',
            'Cormorant',
            'Cormorant Garamond',
            'Cormorant Infant',
            'Cormorant SC',
            'Cormorant Unicase',
            'Cormorant Upright',
            'Courgette',
            'Cousine',
            'Coustard',
            'Covered By Your Grace',
            'Crafty Girls',
            'Creepster',
            'Crete Round',
            'Crimson Text',
            'Croissant One',
            'Crushed',
            'Cuprum',
            'Cute Font',
            'Cutive',
            'Cutive Mono',
            'Damion',
            'Dancing Script',
            'Dangrek',
            'David Libre',
            'Dawning of a New Day',
            'Days One',
            'Dekko',
            'Delius',
            'Delius Swash Caps',
            'Delius Unicase',
            'Della Respira',
            'Denk One',
            'Devonshire',
            'Dhurjati',
            'Didact Gothic',
            'Diplomata',
            'Diplomata SC',
            'Do Hyeon',
            'Dokdo',
            'Domine',
            'Donegal One',
            'Doppio One',
            'Dorsa',
            'Dosis',
            'Dr Sugiyama',
            'Duru Sans',
            'Dynalight',
            'EB Garamond',
            'Eagle Lake',
            'East Sea Dokdo',
            'Eater',
            'Economica',
            'Eczar',
            'El Messiri',
            'Electrolize',
            'Elsie',
            'Elsie Swash Caps',
            'Emblema One',
            'Emilys Candy',
            'Encode Sans',
            'Encode Sans Condensed',
            'Encode Sans Expanded',
            'Encode Sans Semi Condensed',
            'Encode Sans Semi Expanded',
            'Engagement',
            'Englebert',
            'Enriqueta',
            'Erica One',
            'Esteban',
            'Euphoria Script',
            'Ewert',
            'Exo',
            'Exo 2',
            'Expletus Sans',
            'Fahkwang',
            'Fanwood Text',
            'Farsan',
            'Fascinate',
            'Fascinate Inline',
            'Faster One',
            'Fasthand',
            'Fauna One',
            'Faustina',
            'Federant',
            'Federo',
            'Felipa',
            'Fenix',
            'Finger Paint',
            'Fira Mono',
            'Fira Sans',
            'Fira Sans Condensed',
            'Fira Sans Extra Condensed',
            'Fjalla One',
            'Fjord One',
            'Flamenco',
            'Flavors',
            'Fondamento',
            'Fontdiner Swanky',
            'Forum',
            'Francois One',
            'Frank Ruhl Libre',
            'Freckle Face',
            'Fredericka the Great',
            'Fredoka One',
            'Freehand',
            'Fresca',
            'Frijole',
            'Fruktur',
            'Fugaz One',
            'GFS Didot',
            'GFS Neohellenic',
            'Gabriela',
            'Gaegu',
            'Gafata',
            'Galada',
            'Galdeano',
            'Galindo',
            'Gamja Flower',
            'Gentium Basic',
            'Gentium Book Basic',
            'Geo',
            'Geostar',
            'Geostar Fill',
            'Germania One',
            'Gidugu',
            'Gilda Display',
            'Give You Glory',
            'Glass Antiqua',
            'Glegoo',
            'Gloria Hallelujah',
            'Goblin One',
            'Gochi Hand',
            'Gorditas',
            'Gothic A1',
            'Goudy Bookletter 1911',
            'Graduate',
            'Grand Hotel',
            'Gravitas One',
            'Great Vibes',
            'Griffy',
            'Gruppo',
            'Gudea',
            'Gugi',
            'Gurajada',
            'Habibi',
            'Halant',
            'Hammersmith One',
            'Hanalei',
            'Hanalei Fill',
            'Handlee',
            'Hanuman',
            'Happy Monkey',
            'Harmattan',
            'Headland One',
            'Heebo',
            'Henny Penny',
            'Herr Von Muellerhoff',
            'Hi Melody',
            'Hind',
            'Hind Guntur',
            'Hind Madurai',
            'Hind Siliguri',
            'Hind Vadodara',
            'Holtwood One SC',
            'Homemade Apple',
            'Homenaje',
            'IBM Plex Mono',
            'IBM Plex Sans',
            'IBM Plex Sans Condensed',
            'IBM Plex Serif',
            'IM Fell DW Pica',
            'IM Fell DW Pica SC',
            'IM Fell Double Pica',
            'IM Fell Double Pica SC',
            'IM Fell English',
            'IM Fell English SC',
            'IM Fell French Canon',
            'IM Fell French Canon SC',
            'IM Fell Great Primer',
            'IM Fell Great Primer SC',
            'Iceberg',
            'Iceland',
            'Imprima',
            'Inconsolata',
            'Inder',
            'Indie Flower',
            'Inika',
            'Inknut Antiqua',
            'Irish Grover',
            'Istok Web',
            'Italiana',
            'Italianno',
            'Itim',
            'Jacques Francois',
            'Jacques Francois Shadow',
            'Jaldi',
            'Jim Nightshade',
            'Jockey One',
            'Jolly Lodger',
            'Jomhuria',
            'Josefin Sans',
            'Josefin Slab',
            'Joti One',
            'Jua',
            'Judson',
            'Julee',
            'Julius Sans One',
            'Junge',
            'Jura',
            'Just Another Hand',
            'Just Me Again Down Here',
            'K2D',
            'Kadwa',
            'Kalam',
            'Kameron',
            'Kanit',
            'Kantumruy',
            'Karla',
            'Karma',
            'Katibeh',
            'Kaushan Script',
            'Kavivanar',
            'Kavoon',
            'Kdam Thmor',
            'Keania One',
            'Kelly Slab',
            'Kenia',
            'Khand',
            'Khmer',
            'Khula',
            'Kirang Haerang',
            'Kite One',
            'Knewave',
            'KoHo',
            'Kodchasan',
            'Kosugi',
            'Kosugi Maru',
            'Kotta One',
            'Koulen',
            'Kranky',
            'Kreon',
            'Kristi',
            'Krona One',
            'Krub',
            'Kumar One',
            'Kumar One Outline',
            'Kurale',
            'La Belle Aurore',
            'Laila',
            'Lakki Reddy',
            'Lalezar',
            'Lancelot',
            'Lateef',
            'Lato',
            'League Script',
            'Leckerli One',
            'Ledger',
            'Lekton',
            'Lemon',
            'Lemonada',
            'Life Savers',
            'Lilita One',
            'Lily Script One',
            'Limelight',
            'Linden Hill',
            'Lobster',
            'Lobster Two',
            'Londrina Outline',
            'Londrina Shadow',
            'Londrina Sketch',
            'Londrina Solid',
            'Lora',
            'Love Ya Like A Sister',
            'Loved by the King',
            'Lovers Quarrel',
            'Luckiest Guy',
            'Lusitana',
            'Lustria',
            'M PLUS 1p',
            'M PLUS Rounded 1c',
            'Macondo',
            'Macondo Swash Caps',
            'Mada',
            'Magra',
            'Maiden Orange',
            'Maitree',
            'Mako',
            'Mali',
            'Mallanna',
            'Mandali',
            'Manuale',
            'Marcellus',
            'Marcellus SC',
            'Marck Script',
            'Margarine',
            'Markazi Text',
            'Marko One',
            'Marmelad',
            'Martel',
            'Martel Sans',
            'Marvel',
            'Mate',
            'Mate SC',
            'Maven Pro',
            'McLaren',
            'Meddon',
            'MedievalSharp',
            'Medula One',
            'Meera Inimai',
            'Megrim',
            'Meie Script',
            'Merienda',
            'Merienda One',
            'Merriweather',
            'Merriweather Sans',
            'Metal',
            'Metal Mania',
            'Metamorphous',
            'Metrophobic',
            'Michroma',
            'Milonga',
            'Miltonian',
            'Miltonian Tattoo',
            'Mina',
            'Miniver',
            'Miriam Libre',
            'Mirza',
            'Miss Fajardose',
            'Mitr',
            'Modak',
            'Modern Antiqua',
            'Mogra',
            'Molengo',
            'Molle',
            'Monda',
            'Monofett',
            'Monoton',
            'Monsieur La Doulaise',
            'Montaga',
            'Montez',
            'Montserrat',
            'Montserrat Alternates',
            'Montserrat Subrayada',
            'Moul',
            'Moulpali',
            'Mountains of Christmas',
            'Mouse Memoirs',
            'Mr Bedfort',
            'Mr Dafoe',
            'Mr De Haviland',
            'Mrs Saint Delafield',
            'Mrs Sheppards',
            'Mukta',
            'Mukta Mahee',
            'Mukta Malar',
            'Mukta Vaani',
            'Muli',
            'Mystery Quest',
            'NTR',
            'Nanum Brush Script',
            'Nanum Gothic',
            'Nanum Gothic Coding',
            'Nanum Myeongjo',
            'Nanum Pen Script',
            'Neucha',
            'Neuton',
            'New Rocker',
            'News Cycle',
            'Niconne',
            'Niramit',
            'Nixie One',
            'Nobile',
            'Nokora',
            'Norican',
            'Nosifer',
            'Notable',
            'Nothing You Could Do',
            'Noticia Text',
            'Noto Sans',
            'Noto Sans JP',
            'Noto Sans KR',
            'Noto Serif',
            'Noto Serif JP',
            'Noto Serif KR',
            'Nova Cut',
            'Nova Flat',
            'Nova Mono',
            'Nova Oval',
            'Nova Round',
            'Nova Script',
            'Nova Slim',
            'Nova Square',
            'Numans',
            'Nunito',
            'Nunito Sans',
            'Odor Mean Chey',
            'Offside',
            'Old Standard TT',
            'Oldenburg',
            'Oleo Script',
            'Oleo Script Swash Caps',
            'Open Sans',
            'Open Sans Condensed',
            'Oranienbaum',
            'Orbitron',
            'Oregano',
            'Orienta',
            'Original Surfer',
            'Oswald',
            'Over the Rainbow',
            'Overlock',
            'Overlock SC',
            'Overpass',
            'Overpass Mono',
            'Ovo',
            'Oxygen',
            'Oxygen Mono',
            'PT Mono',
            'PT Sans',
            'PT Sans Caption',
            'PT Sans Narrow',
            'PT Serif',
            'PT Serif Caption',
            'Pacifico',
            'Padauk',
            'Palanquin',
            'Palanquin Dark',
            'Pangolin',
            'Paprika',
            'Parisienne',
            'Passero One',
            'Passion One',
            'Pathway Gothic One',
            'Patrick Hand',
            'Patrick Hand SC',
            'Pattaya',
            'Patua One',
            'Pavanam',
            'Paytone One',
            'Peddana',
            'Peralta',
            'Permanent Marker',
            'Petit Formal Script',
            'Petrona',
            'Philosopher',
            'Piedra',
            'Pinyon Script',
            'Pirata One',
            'Plaster',
            'Play',
            'Playball',
            'Playfair Display',
            'Playfair Display SC',
            'Podkova',
            'Poiret One',
            'Poller One',
            'Poly',
            'Pompiere',
            'Pontano Sans',
            'Poor Story',
            'Poppins',
            'Port Lligat Sans',
            'Port Lligat Slab',
            'Pragati Narrow',
            'Prata',
            'Preahvihear',
            'Press Start 2P',
            'Pridi',
            'Princess Sofia',
            'Prociono',
            'Prompt',
            'Prosto One',
            'Proza Libre',
            'Puritan',
            'Purple Purse',
            'Quando',
            'Quantico',
            'Quattrocento',
            'Quattrocento Sans',
            'Questrial',
            'Quicksand',
            'Quintessential',
            'Qwigley',
            'Racing Sans One',
            'Radley',
            'Rajdhani',
            'Rakkas',
            'Raleway',
            'Raleway Dots',
            'Ramabhadra',
            'Ramaraja',
            'Rambla',
            'Rammetto One',
            'Ranchers',
            'Rancho',
            'Ranga',
            'Rasa',
            'Rationale',
            'Ravi Prakash',
            'Redressed',
            'Reem Kufi',
            'Reenie Beanie',
            'Revalia',
            'Rhodium Libre',
            'Ribeye',
            'Ribeye Marrow',
            'Righteous',
            'Risque',
            'Roboto',
            'Roboto Condensed',
            'Roboto Mono',
            'Roboto Slab',
            'Rochester',
            'Rock Salt',
            'Rokkitt',
            'Romanesco',
            'Ropa Sans',
            'Rosario',
            'Rosarivo',
            'Rouge Script',
            'Rozha One',
            'Rubik',
            'Rubik Mono One',
            'Ruda',
            'Rufina',
            'Ruge Boogie',
            'Ruluko',
            'Rum Raisin',
            'Ruslan Display',
            'Russo One',
            'Ruthie',
            'Rye',
            'Sacramento',
            'Sahitya',
            'Sail',
            'Saira',
            'Saira Condensed',
            'Saira Extra Condensed',
            'Saira Semi Condensed',
            'Salsa',
            'Sanchez',
            'Sancreek',
            'Sansita',
            'Sarala',
            'Sarina',
            'Sarpanch',
            'Satisfy',
            'Sawarabi Gothic',
            'Sawarabi Mincho',
            'Scada',
            'Scheherazade',
            'Schoolbell',
            'Scope One',
            'Seaweed Script',
            'Secular One',
            'Sedgwick Ave',
            'Sedgwick Ave Display',
            'Sevillana',
            'Seymour One',
            'Shadows Into Light',
            'Shadows Into Light Two',
            'Shanti',
            'Share',
            'Share Tech',
            'Share Tech Mono',
            'Shojumaru',
            'Short Stack',
            'Shrikhand',
            'Siemreap',
            'Sigmar One',
            'Signika',
            'Signika Negative',
            'Simonetta',
            'Sintony',
            'Sirin Stencil',
            'Six Caps',
            'Skranji',
            'Slabo 13px',
            'Slabo 27px',
            'Slackey',
            'Smokum',
            'Smythe',
            'Sniglet',
            'Snippet',
            'Snowburst One',
            'Sofadi One',
            'Sofia',
            'Song Myung',
            'Sonsie One',
            'Sorts Mill Goudy',
            'Source Code Pro',
            'Source Sans Pro',
            'Source Serif Pro',
            'Space Mono',
            'Special Elite',
            'Spectral',
            'Spectral SC',
            'Spicy Rice',
            'Spinnaker',
            'Spirax',
            'Squada One',
            'Sree Krushnadevaraya',
            'Sriracha',
            'Srisakdi',
            'Stalemate',
            'Stalinist One',
            'Stardos Stencil',
            'Stint Ultra Condensed',
            'Stint Ultra Expanded',
            'Stoke',
            'Strait',
            'Stylish',
            'Sue Ellen Francisco',
            'Suez One',
            'Sumana',
            'Sunflower',
            'Sunshiney',
            'Supermercado One',
            'Sura',
            'Suranna',
            'Suravaram',
            'Suwannaphum',
            'Swanky and Moo Moo',
            'Syncopate',
            'Tajawal',
            'Tangerine',
            'Taprom',
            'Tauri',
            'Taviraj',
            'Teko',
            'Telex',
            'Tenali Ramakrishna',
            'Tenor Sans',
            'Text Me One',
            'The Girl Next Door',
            'Tienne',
            'Tillana',
            'Timmana',
            'Tinos',
            'Titan One',
            'Titillium Web',
            'Trade Winds',
            'Trirong',
            'Trocchi',
            'Trochut',
            'Trykker',
            'Tulpen One',
            'Ubuntu',
            'Ubuntu Condensed',
            'Ubuntu Mono',
            'Ultra',
            'Uncial Antiqua',
            'Underdog',
            'Unica One',
            'UnifrakturCook',
            'UnifrakturMaguntia',
            'Unkempt',
            'Unlock',
            'Unna',
            'VT323',
            'Vampiro One',
            'Varela',
            'Varela Round',
            'Vast Shadow',
            'Vesper Libre',
            'Vibur',
            'Vidaloka',
            'Viga',
            'Voces',
            'Volkhov',
            'Vollkorn',
            'Vollkorn SC',
            'Voltaire',
            'Waiting for the Sunrise',
            'Wallpoet',
            'Walter Turncoat',
            'Warnes',
            'Wellfleet',
            'Wendy One',
            'Wire One',
            'Work Sans',
            'Yanone Kaffeesatz',
            'Yantramanav',
            'Yatra One',
            'Yellowtail',
            'Yeon Sung',
            'Yeseva One',
            'Yesteryear',
            'Yrsa',
            'Zeyada',
            'Zilla Slab',
            'Zilla Slab Highlight',
            );
        }

        function bookingpress_get_site_current_language()
        {
            $bookingpress_site_current_language = get_locale();
            if ($bookingpress_site_current_language == 'ru_RU' ) {
                $bookingpress_site_current_language = 'ru';
            } elseif ($bookingpress_site_current_language == 'bs_BA' ) {
                $bookingpress_site_current_language = 'ba';// bosnia
            } elseif ($bookingpress_site_current_language == 'vi' ) {
                $bookingpress_site_current_language = 'vn';// Vietnamese
            } elseif ($bookingpress_site_current_language == 'sw' ) {
                $bookingpress_site_current_language = 'se';// Swedish
            } elseif ($bookingpress_site_current_language == 'ar' ) {
                $bookingpress_site_current_language = 'ar'; // arabic
            } elseif ($bookingpress_site_current_language == 'bg_BG' ) {
                $bookingpress_site_current_language = 'bg'; // Bulgeria
            } elseif ($bookingpress_site_current_language == 'en_CA' ) {
                $bookingpress_site_current_language = 'ca'; // Canada
            } elseif ($bookingpress_site_current_language == 'da_DK' || $bookingpress_site_current_language == 'de_AT' || $bookingpress_site_current_language == 'de_CH' || $bookingpress_site_current_language == 'de_DE_formal' ) {
                $bookingpress_site_current_language = 'da'; // Denmark
            } elseif ($bookingpress_site_current_language == 'de_DE' || $bookingpress_site_current_language == 'de_CH_informal' ) {
                $bookingpress_site_current_language = 'de'; // Germany
            } elseif ($bookingpress_site_current_language == 'el' ) {
                $bookingpress_site_current_language = 'el'; // Greece
            } elseif ($bookingpress_site_current_language == 'es_ES' ) {
                $bookingpress_site_current_language = 'es'; // Spain
            } elseif ($bookingpress_site_current_language == 'fr_FR' ) {
                $bookingpress_site_current_language = 'fr'; // France
            } elseif ($bookingpress_site_current_language == 'hr' ) {
                $bookingpress_site_current_language = 'hr'; // Croatia
            } elseif ($bookingpress_site_current_language == 'hu_HU' ) {
                $bookingpress_site_current_language = 'hu'; // Hungary
            } elseif ($bookingpress_site_current_language == 'id_ID' ) {
                $bookingpress_site_current_language = 'id'; // Indonesia
            } elseif ($bookingpress_site_current_language == 'is_IS' ) {
                $bookingpress_site_current_language = 'is'; // Iceland
            } elseif ($bookingpress_site_current_language == 'it_IT' ) {
                $bookingpress_site_current_language = 'it'; // Italy
            } elseif ($bookingpress_site_current_language == 'ja' ) {
                $bookingpress_site_current_language = 'ja'; // Japan
            } elseif ($bookingpress_site_current_language == 'ko_KR' ) {
                $bookingpress_site_current_language = 'ko'; // Korean
            } elseif ($bookingpress_site_current_language == 'lt_LT' ) {
                $bookingpress_site_current_language = 'lt'; // Lithunian
            } elseif ($bookingpress_site_current_language == 'mn' ) {
                $bookingpress_site_current_language = 'mn'; // Mongolia
            } elseif ($bookingpress_site_current_language == 'nl_NL' ) {
                $bookingpress_site_current_language = 'nl'; // Netherlands
            } elseif ($bookingpress_site_current_language == 'pl_PL' ) {
                $bookingpress_site_current_language = 'pl'; // Poland
            } elseif ($bookingpress_site_current_language == 'pt_BR' ) {
                $bookingpress_site_current_language = 'pt-br'; // Portuguese
            } elseif ($bookingpress_site_current_language == 'ro_RO' ) {
                $bookingpress_site_current_language = 'ro'; // Romania
            } elseif ($bookingpress_site_current_language == 'sk_SK' ) {
                $bookingpress_site_current_language = 'sk'; // Slovakia
            } elseif ($bookingpress_site_current_language == 'sl_SI' ) {
                $bookingpress_site_current_language = 'sl'; // Slovenia
            } elseif ($bookingpress_site_current_language == 'sq' ) {
                $bookingpress_site_current_language = 'sq'; // Albanian
            } elseif ($bookingpress_site_current_language == 'sr_RS' ) {
                $bookingpress_site_current_language = 'sr'; // Suriname
            } elseif ($bookingpress_site_current_language == 'sv_SE' ) {
                $bookingpress_site_current_language = 'sv'; // El Salvador
            } elseif ($bookingpress_site_current_language == 'tr_TR' ) {
                $bookingpress_site_current_language = 'tr'; // Turkey
            } elseif ($bookingpress_site_current_language == 'uk' ) {
                $bookingpress_site_current_language = 'uk'; // Ukrain
            } elseif ($bookingpress_site_current_language == 'vi' ) {
                $bookingpress_site_current_language = 'vi'; // Virgin Islands (U.S.)
            } elseif ($bookingpress_site_current_language == 'zh_CN' ) {
                $bookingpress_site_current_language = 'zh-cn'; // Chinese
            } else {
                $bookingpress_site_current_language = 'en';
            }

            return $bookingpress_site_current_language;
        }
    }
}
global $bookingpress_global_options,$bookingpress_notification_duration;
$bookingpress_global_options        = new BookingPress_Global_Options();
$bookingpress_notification_duration = '1500';


