<?php

global $BookingPress, $wpdb, $bookingpress_version;

$bookingpress_old_version = get_option('bookingpress_version', true);

if (version_compare($bookingpress_old_version, '1.0.2', '<') ) {
    $tbl_bookingpress_default_workhours = $wpdb->prefix . 'bookingpress_default_workhours';
    $wpdb->query("UPDATE `{$tbl_bookingpress_default_workhours}` SET `bookingpress_start_time` = NULL, bookingpress_end_time = NULL WHERE bookingpress_start_time = '00:00:00' AND bookingpress_end_time = '00:00:00'"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_default_workhours is table name defined globally. False Positive alarm
}


if (version_compare($bookingpress_old_version, '1.0.3', '<') ) {
    $args  = array(
    'role'   => 'administrator',
    'fields' => 'id',
    );
    $users = get_users($args);

    if (count($users) > 0 ) {
        foreach ( $users as $key => $user_id ) {
            $bookingpressroles = $BookingPress->bookingpress_capabilities();
            $userObj           = new WP_User($user_id);
            foreach ( $bookingpressroles as $bookingpressrole => $bookingpress_roledescription ) {
                $userObj->add_cap($bookingpressrole);
            }
            unset($bookingpressrole);
            unset($bookingpressroles);
            unset($bookingpress_roledescription);
        }
    }
}

if (version_compare($bookingpress_old_version, '1.0.6', '<') ) {
    $tbl_bookingpress_entries = $wpdb->prefix . 'bookingpress_entries';
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_entries} ADD bookingpress_customer_id INT(11) DEFAULT NULL AFTER bookingpress_entry_id"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_entries is table name defined globally. False Positive alarm

    $tbl_bookingpress_users = $wpdb->prefix . 'bookingpress_users';
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_users} CHANGE bookingpress_wpuser_id bookingpress_wpuser_id INT(11) NULL DEFAULT NULL"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_users is table name defined globally. False Positive alarm
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_users} CHANGE bookingpress_user_password bookingpress_user_password VARCHAR(255) NULL DEFAULT NULL"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_users is table name defined globally. False Positive alarm
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_users} CHANGE bookingpress_user_country_phone bookingpress_user_country_phone VARCHAR(60) NULL DEFAULT NULL"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_users is table name defined globally. False Positive alarm

    $tbl_bookingpress_appointment_bookings = $wpdb->prefix . 'bookingpress_appointment_bookings';
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_appointment_bookings} ADD bookingpress_entry_id INT(11) DEFAULT NULL AFTER bookingpress_appointment_booking_id"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_appointment_bookings is table name defined globally. False Positive alarm

    // Update customers avatar to usermeta table
    $tbl_bookingpress_users_meta = $wpdb->prefix . 'bookingpress_usermeta';

    include_once ABSPATH . 'wp-admin/includes/upgrade.php';
    @set_time_limit(0);

    $charset_collate = '';
    if ($wpdb->has_cap('collation') ) {
        if (! empty($wpdb->charset) ) {
            $charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";
        }
        if (! empty($wpdb->collate) ) {
            $charset_collate .= " COLLATE $wpdb->collate";
        }
    }
    $bookingpress_dbtbl_create = array();
    $sql_table                 = "DROP TABLE IF EXISTS `{$tbl_bookingpress_users_meta}`;
    CREATE TABLE IF NOT EXISTS `{$tbl_bookingpress_users_meta}`(
        `bookingpress_usermeta_id` int(11) NOT NULL AUTO_INCREMENT,
        `bookingpress_customer_id` int(11) NOT NULL,
        `bookingpress_usermeta_key` TEXT NOT NULL,
        `bookingpress_usermeta_value` TEXT DEFAULT NULL,
        `bookingpress_usermeta_created_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
        PRIMARY KEY (`bookingpress_usermeta_id`)
    ) {$charset_collate};";

    $bookingpress_dbtbl_create[ $tbl_bookingpress_users_meta ] = dbDelta($sql_table);

    $bookingpress_customer_avatar_details = array();

    $bookingpress_customers_details = $wpdb->get_results("SELECT * FROM {$tbl_bookingpress_users} WHERE bookingpress_user_type = 2", ARRAY_A); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_users is table name defined globally. False Positive alarm
    if (is_array($bookingpress_customers_details) && ! empty($bookingpress_customers_details) ) {
        foreach ( $bookingpress_customers_details as $customer_detail_key => $customer_detail_val ) {
            $customer_id = $customer_detail_val['bookingpress_customer_id'];
            $wpuser_id   = $customer_detail_val['bookingpress_wpuser_id'];

            if (! empty($customer_id) && ! empty($wpuser_id) ) {
                $bookingpress_get_existing_avatar_details = get_user_meta($wpuser_id, 'customer_avatar_details', true);
                if (! empty($bookingpress_get_existing_avatar_details) ) {
                    $bookingpress_customer_avatar_details[] = array(
                    'bookingpress_customer_id'    => $customer_id,
                    'bookingpress_usermeta_key'   => 'customer_avatar_details',
                    'bookingpress_usermeta_value' => $bookingpress_get_existing_avatar_details,
                    );
                }
            }
        }
    }

    if (is_array($bookingpress_customer_avatar_details) && ! empty($bookingpress_customer_avatar_details) ) {
        foreach ( $bookingpress_customer_avatar_details as $customer_avatar_key => $customer_avatar_val ) {
            $BookingPress->update_bookingpress_usermeta($customer_avatar_val['bookingpress_customer_id'], $customer_avatar_val['bookingpress_usermeta_key'], maybe_serialize($customer_avatar_val['bookingpress_usermeta_value']));
        }
    }
}

if (version_compare($bookingpress_old_version, '1.0.9', '<') ) {
    $tbl_bookingpress_entries           = $wpdb->prefix . 'bookingpress_entries';
    $tbl_bookingpress_users             = $wpdb->prefix . 'bookingpress_users';
    $tbl_bookingpress_users_meta        = $wpdb->prefix . 'bookingpress_usermeta';
    $tbl_bookingpress_customers         = $wpdb->prefix . 'bookingpress_customers';
    $tbl_bookingpress_customers_meta    = $wpdb->prefix . 'bookingpress_customers_meta';
    $tbl_bookingpress_default_workhours = $wpdb->prefix . 'bookingpress_default_workhours';
     // phpcs:disable WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_default_daysoff,$tbl_bookingpress_users,$tbl_bookingpress_users_meta, $tbl_bookingpress_default_workhours are table names. False Positive alarm
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_entries} CHANGE bookingpress_user_id bookingpress_customer_id bigint(11) DEFAULT NULL");
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_users} CHANGE bookingpress_user_id bookingpress_customer_id bigint(11) NOT NULL AUTO_INCREMENT");
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_users_meta} CHANGE bookingpress_usermeta_id bookingpress_customermeta_id bigint(11) NOT NULL AUTO_INCREMENT");
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_users_meta} CHANGE bookingpress_user_id bookingpress_customer_id bigint(11) NOT NULL");
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_users_meta} CHANGE bookingpress_usermeta_key bookingpress_customersmeta_key TEXT NOT NULL");
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_users_meta} CHANGE bookingpress_usermeta_value bookingpress_customersmeta_value TEXT DEFAULT NULL");
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_users_meta} CHANGE bookingpress_usermeta_created_date bookingpress_customersmeta_created_date datetime NOT NULL DEFAULT CURRENT_TIMESTAMP");


    $wpdb->query("ALTER TABLE {$tbl_bookingpress_users} DROP COLUMN bookingpress_user_password");

    $wpdb->query("ALTER TABLE {$tbl_bookingpress_default_workhours} CHANGE bookingpress_employee_workhours_id bookingpress_workhours_id smallint NOT NULL AUTO_INCREMENT");
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_default_workhours} CHANGE bookingpress_employee_workday_key bookingpress_workday_key varchar(11) NOT NULL");

    // RENAME TABLE wpa_bookingpress_users TO wpa_bookingpress_customers
    $wpdb->query("RENAME TABLE {$tbl_bookingpress_users} TO {$tbl_bookingpress_customers}");
    $wpdb->query("RENAME TABLE {$tbl_bookingpress_users_meta} TO {$tbl_bookingpress_customers_meta}");
     // phpcs:enable
}

if (version_compare($bookingpress_old_version, '1.0.12', '<') ) {
    global $BookingPress;

    $tbl_bookingpress_customers = $wpdb->prefix . 'bookingpress_customers';
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_customers} ADD bookingpress_created_at INT(11)  NOT NULL DEFAULT 0  AFTER bookingpress_user_country_phone"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_customers is table name defined globally. False Positive alarm
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_customers} ADD bookingpress_created_by INT(1)  NOT NULL DEFAULT 0 AFTER bookingpress_created_at"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_customers is table name defined globally. False Positive alarm
    $tbl_bookingpress_payment_logs = $wpdb->prefix . 'bookingpress_payment_logs';
    $is_update_column              = $wpdb->query("ALTER TABLE {$tbl_bookingpress_payment_logs} ADD bookingpress_invoice_id bigint(11)  NOT NULL DEFAULT 0  AFTER bookingpress_payment_log_id"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_payment_logs is table name defined globally. False Positive alarm
    if ($is_update_column ) {
        $bookingpress_payment_log_data = $wpdb->get_results('SELECT `bookingpress_payment_log_id` FROM ' . $tbl_bookingpress_payment_logs); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_payment_logs is table name defined globally. False Positive alarm
        $i                             = 0;
        if (! empty($bookingpress_payment_log_data) ) {
            foreach ( $bookingpress_payment_log_data as $log_data ) {
                $i++;
                $bookingpress_log_id = $log_data->bookingpress_payment_log_id;
                $wpdb->update(
                    $tbl_bookingpress_payment_logs,
                    array(
                    'bookingpress_invoice_id' => $i,
                    ),
                    array( 'bookingpress_payment_log_id' => $bookingpress_log_id ),
                    array( '%d' ),
                    array( '%d' )
                );
            }
        }
        $BookingPress->bookingpress_update_settings('bookingpress_last_invoice_id', 'invoice_setting', $i);
    }
}

if (version_compare($bookingpress_old_version, '1.0.13', '<') ) {
    global $BookingPress;
    $tbl_bookingpress_settings = $wpdb->prefix . 'bookingpress_settings';

    $bookingpress_approve_redirection_page_id = $bookingpress_pending_redirection_page_id = $bookingpress_canceled_redirection_page_id = 0;

    // Get default thankyou page id & cancel page id
    $bookingpress_wp_pages = get_pages();
    $bookingpress_wp_pages = json_decode(json_encode($bookingpress_wp_pages), true);
    foreach ( $bookingpress_wp_pages as $bookingpress_page_key => $bookingpress_page_val ) {
        if ($bookingpress_page_val['post_name'] == 'thank-you' ) {
            $bookingpress_pending_redirection_page_id = $bookingpress_approve_redirection_page_id = $bookingpress_page_val['ID'];
        }

        if ($bookingpress_page_val['post_name'] == 'cancel-appointment' ) {
            $bookingpress_canceled_redirection_page_id = $bookingpress_page_val['ID'];
        }
    }

    // Get current redirection urls
    $bookingpress_approve_redirection_url = $wpdb->get_row($wpdb->prepare("SELECT * FROM {$tbl_bookingpress_settings} WHERE setting_name = %s", 'redirect_url_after_booking_approved'), ARRAY_A); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_settings is table name defined globally. False Positive alarm
    if ($bookingpress_approve_redirection_url ) {
        $bookingpress_approve_redirection_tmp_page_id = url_to_postid($bookingpress_approve_redirection_url['setting_value']);
        if (! empty($bookingpress_approve_redirection_tmp_page_id) ) {
            $bookingpress_approve_redirection_page_id = $bookingpress_approve_redirection_tmp_page_id;
        }
    }

    $bookingpress_pending_redirection_url = $wpdb->get_row($wpdb->prepare("SELECT * FROM {$tbl_bookingpress_settings} WHERE setting_name = %s", 'redirect_url_after_booking_pending'), ARRAY_A); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_settings is table name defined globally. False Positive alarm
    if (! empty($bookingpress_pending_redirection_url) ) {
        $bookingpress_pending_redirection_tmp_page_id = url_to_postid($bookingpress_pending_redirection_url['setting_value']);
        if (! empty($bookingpress_pending_redirection_tmp_page_id) ) {
            $bookingpress_pending_redirection_page_id = $bookingpress_pending_redirection_tmp_page_id;
        }
    }

    $bookingpress_canceled_redirection_url = $wpdb->get_row($wpdb->prepare("SELECT * FROM {$tbl_bookingpress_settings} WHERE setting_name = %s", 'redirect_url_after_booking_canceled'), ARRAY_A); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_settings is table name defined globally. False Positive alarm
    if (! empty($bookingpress_canceled_redirection_url) ) {
        $bookingpress_canceled_redirection_tmp_page_id = url_to_postid($bookingpress_canceled_redirection_url['setting_value']);
        if (! empty($bookingpress_canceled_redirection_tmp_page_id) ) {
            $bookingpress_canceled_redirection_page_id = $bookingpress_canceled_redirection_tmp_page_id;
        }
    }

    $bookingpress_redirection_rule_setting_form = array(
    'after_appointment_approved_redirection_type'      => 'fixed_redirection',
    'after_appointment_approved_fixed_redirection_val' => $bookingpress_approve_redirection_page_id,
    'after_appointment_pending_redirection_type'       => 'fixed_redirection',
    'after_appointment_pending_fixed_redirection_val'  => $bookingpress_pending_redirection_page_id,
    'after_appointment_canceled_redirection_type'      => 'fixed_redirection',
    'after_appointment_canceled_fixed_redirection_val' => $bookingpress_canceled_redirection_page_id,
    );

    foreach ( $bookingpress_redirection_rule_setting_form as $bookingpress_redirection_rule_setting_key => $bookingpress_redirection_rule_setting_val ) {
        $BookingPress->bookingpress_update_settings($bookingpress_redirection_rule_setting_key, 'redirection_rule_setting_form', $bookingpress_redirection_rule_setting_val);
    }

    $BookingPress->bookingpress_update_settings('share_timeslot_between_services', 'general_setting', false);
}

if (version_compare($bookingpress_old_version, '1.0.14', '<') ) {

    $tbl_bookingpress_settings = $wpdb->prefix . 'bookingpress_settings';
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_settings} CHANGE setting_value setting_value TEXT NULL DEFAULT NULL"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_settings is table name defined globally. False Positive alarm

    $tbl_bookingpress_entries              = $wpdb->prefix . 'bookingpress_entries';
    $tbl_bookingpress_appointment_bookings = $wpdb->prefix . 'bookingpress_appointment_bookings';
    $tbl_bookingpress_payment_logs         = $wpdb->prefix . 'bookingpress_payment_logs';
     // phpcs:disable WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_entries, $tbl_bookingpress_appointment_bookings,$tbl_bookingpress_payment_logs are table names. False Positive alarm
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_entries} CHANGE bookingpress_service_currency bookingpress_service_currency VARCHAR(100) ");
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_appointment_bookings} CHANGE bookingpress_service_currency bookingpress_service_currency VARCHAR(100) ");
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_payment_logs} CHANGE bookingpress_payment_currency bookingpress_payment_currency VARCHAR(100) ");
    // phpcs:enable
}

if (version_compare($bookingpress_old_version, '1.0.15', '<') ) {
    $tbl_bookingpress_form_fields = $wpdb->prefix . 'bookingpress_form_fields';
    $wpdb->query("ALTER TABLE {$tbl_bookingpress_form_fields} CHANGE `bookingpress_field_position` `bookingpress_field_position` FLOAT NULL DEFAULT '0';"); // phpcs:ignore WordPress.DB.PreparedSQL.InterpolatedNotPrepared -- Reason: $tbl_bookingpress_form_fields is table name defined globally. False Positive alarm
}
if (version_compare($bookingpress_old_version, '1.0.18', '<') ) {
    global $BookingPress;
    $bookingpress_db_fields = array(
        'bookingpress_setting_name'  => 'all_category_title',
        'bookingpress_setting_value' => 'ALL',
        'bookingpress_setting_type'  => 'booking_form',
    );    
    $tbl_bookingpress_customize_settings = $wpdb->prefix . 'bookingpress_customize_settings';
    $wpdb->insert($tbl_bookingpress_customize_settings, $bookingpress_db_fields);

    $BookingPress->bookingpress_update_settings('no_payment_method_available', 'message_setting', 'Oops! There is no payment method available.');
}  
$bookingpress_new_version = '1.0.19';
update_option('bookingpress_new_version_installed', 1);
update_option('bookingpress_version', $bookingpress_new_version);
update_option('bookingpress_updated_date_' . $bookingpress_new_version, current_time('mysql'));


