(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define('element/locale/bul', ['module', 'exports'], factory);
  } else if (typeof exports !== "undefined") {
    factory(module, exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod, mod.exports);
    global.ELEMENT.lang = global.ELEMENT.lang || {}; 
    global.ELEMENT.lang.bul = mod.exports;
  }
})(this, function (module, exports) {
  'use strict';

  exports.__esModule = true;
  exports.default = {
    el: {
      colorpicker: {
        confirm: 'потвърди',
        clear: 'ясно'
      },
      datepicker: {
        now: 'сега',
        today: 'днес',
        cancel: 'отменете',
        clear: 'ясно',
        confirm: 'потвърди',
        selectDate: 'изберете Дата',
        selectTime: 'изберете Време',
        startDate: 'начална дата',
        startTime: 'начален час',
        endDate: 'крайна дата',
        endTime: 'крайно време',
        prevYear: 'предишна година',
        nextYear: 'следващата година',
        prevMonth: 'предишен месец',
        nextMonth: 'следващият месец',
        year: 'година',
        month1: 'месец 1',
        month2: 'месец 2',
        month3: 'месец 3',
        month4: 'месец 4',
        month5: 'месец 5',
        month6: 'месец 6',
        month7: 'месец 7',
        month8: 'месец 8',
        month9: 'месец 9',
        month10: 'месец 10',
        month11: 'месец 11',
        month12: 'месец 12',
        // week: 'setmana',
        weeks: {
          sun: 'слънце',
          mon: 'пн',
          tue: 'вт',
          wed: 'ср',
          thu: 'чт',
          fri: 'пет',
          sat: 'седна'
        },
        months: {
          jan: 'ян',
          feb: 'фев',
          mar: 'март',
          apr: 'апр',
          may: 'може',
          jun: 'юни',
          jul: 'юли',
          aug: 'авг',
          sep: 'септ',
          oct: 'окт',
          nov: 'ноемв',
          dec: 'дек'
        }
      },
      select: {
        loading: 'Зареждане',
        noMatch: 'Няма съвпадения',
        noData: 'Няма данни',
        placeholder: 'Изберете'
      },
      cascader: {
        noMatch: 'Няма съвпадения',
        loading: 'Зареждане',
        placeholder: 'Изберете',
        noData: 'Няма данни'
      },
      pagination: {
        goto: 'Отидете на',
        pagesize: '/pagina',
        total: 'Обща сума {total}',
        pageClassifier: ''
      },
      messagebox: {
        confirm: 'OK',
        cancel: 'Отмяна',
        error: 'грешка'
      },
      upload: {
        deleteTip: 'Натиснете изтриване, за да премахнете',
        delete: 'Отмяна',
        preview: 'Визуализация',
        continue: 'Продължи'
      },
      table: {
        emptyText: 'Няма данни',
        confirmFilter: 'Потвърждение',
        resetFilter: 'Нулиране',
        clearFilter: 'всичко',
        sumText: 'Сума'
      },
      tree: {
        emptyText: 'Няма данни'
      },
      transfer: {
        noMatch: 'няма съвпадение',
        noData: 'няма данни',
        titles: ['Llista 1', 'Llista 2'],
        filterPlaceholder: 'filterPlaceholder',
        noCheckedFormat: '{total} ítems',
        hasCheckedFormat: '{checked}/{total} seleccionats'
      },
      image: {
        error: 'грешка'
      },
      pageHeader: {
        title: 'наопаки'
      },
      popconfirm: {
        confirmButtonText: 'да',
        cancelButtonText: 'No'
      },
      empty: {
        description: 'Няма данни'
      }
    }
  };
  module.exports = exports['default'];
});