(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define('element/locale/jp', ['module', 'exports'], factory);
  } else if (typeof exports !== "undefined") {
    factory(module, exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod, mod.exports);
    global.ELEMENT.lang = global.ELEMENT.lang || {}; 
    global.ELEMENT.lang.jp = mod.exports;
  }
})(this, function (module, exports) {
  'use strict';
  exports.__esModule = true;
  exports.default = {
    el: {
      colorpicker: {
        confirm: 'OK',
        clear: 'Pulisci'
      },
      datepicker: {
        now: '今',
        today: '今日',
        cancel: 'キャンセル',
        clear: '掃除',
        confirm: 'OK',
        selectDate: '日付を選択',
        selectTime: '今すぐ選択',
        startDate: '開始日',
        startTime: '今から始めます',
        endDate: '終了日',
        endTime: '終了時間',
        prevYear: '去年',
        nextYear: '来年',
        prevMonth: '前月',
        nextMonth: '来月',
        year: '年',
        month1: '一月',
        month2: '2月',
        month3: '行進',
        month4: '4月',
        month5: '5月',
        month6: '六月',
        month7: '7月',
        month8: '8月',
        month9: '9月',
        month10: '10月',
        month11: '11月',
        month12: '12月',
        // week: 'settimana',
        weeks: {
          sun: '太陽',
          mon: '月曜日',
          tue: '3月',
          wed: '結婚した',
          thu: '木曜',
          fri: '金',
          sat: '土'
        },
        months: {
          jan: '1月',
          feb: '2月',
          mar: '3月',
          apr: '4月',
          may: 'マグ',
          jun: '下',
          jul: '7月',
          aug: '前に',
          sep: 'セットする',
          oct: '10月',
          nov: '11月',
          dec: '12月'
        }
      },
      select: {
        loading: '読み込み中',
        noMatch: '一致するものはありません',
        noData: 'データなし',
        placeholder: '選択する'
      },
      cascader: {
        noMatch: '一致するものはありません',
        loading: '読み込み中',
        placeholder: '選択する',
        noData: 'データなし'
      },
      pagination: {
        goto: 'に移動',
        pagesize: '/pagina',
        total: '合計 {total}',
        pageClassifier: ''
      },
      messagebox: {
        confirm: 'OK',
        cancel: 'キャンセル',
        error: '無効入力'
      },
      upload: {
        deleteTip: '削除するには削除を押します',
        delete: 'キャンセル',
        preview: 'プレビュー',
        continue: '続ける'
      },
      table: {
        emptyText: 'データなし',
        confirmFilter: '確認',
        resetFilter: 'リセット',
        clearFilter: '全員',
        sumText: '和'
      },
      tree: {
        emptyText: 'データなし'
      },
      transfer: {
        noMatch: '一致するものはありません',
        noData: 'データなし',
        titles: ['リスト1', 'リスト2'],
        filterPlaceholder: 'フィルターを挿入',
        noCheckedFormat: '{total} 要素',
        hasCheckedFormat: '{checked}/{total} 選択'
      },
      image: {
        error: 'エラー'
      },
      pageHeader: {
        title: 'バッカーズ'
      },
      popconfirm: {
        confirmButtonText: 'うん',
        cancelButtonText: 'No'
      },
      empty: {
        description: 'データなし'
      }
    }
  };
  module.exports = exports['default'];
});